﻿Type=Class
Version=2.52
@EndOfDesignText@

Sub Class_Globals

	Private fcs1 As facesCls  'NEW: local reference to faceList for sorting!
	Private mm As mainCls
End Sub

Public Sub Initialize(mm0 As mainCls) As Boolean

	mm = mm0
End Sub

'scene and gpu are being assigned/connected to output window (aka. scene_begin())

Public Sub s0_prepare(cam As camera3, gfx As Canvas) 'category: scene_setupObjects()

    'scene.init(100)           'while not really needed, this may speed up starting process (recommended values: 100-1000) 
    mm.scene.camera_assign(cam)   'transform + project context
    mm.scene.graphics_assign(gfx) 'render context (currently unused)

    'gpu.set_fillstyle (gpu.styleSolid)
    mm.gpu.assign_graphics (gfx)

    mm.gpu.plane_z1 = cam.plane_z1 'transfer cam-data to gpu ->
    mm.gpu.plane_z2 = cam.plane_z2
    mm.gpu.lens_scale = cam.lens_scale
    mm.gpu.win_cx = cam.win_cx: mm.gpu.win_cy = cam.win_cy
    mm.gpu.win_x1 = cam.win_x1: mm.gpu.win_y1 = cam.win_y1
    mm.gpu.win_x2 = cam.win_x2: mm.gpu.win_y2 = cam.win_y2
End Sub

'transform and project nodes center/radius, test visibility (-> shape clipstates)
'transform points and face centers/normals

Public Sub s1_shapes_transformTest() 'category: scene_computeObjects()

    Dim n As Int, node As node3
    Dim s As Int, shape As shape3

    n = 0
    Do While (n < mm.nodes.nodeNum): node = mm.nodes.node(n)
        s = 0
        Do While (s < node.shapeNum): shape = mm.shapes.shape(node.shapeIdx(s))
        
            mm.gpu.shape_transformMatrix (shape.form, node.form, shape.gout)
            mm.gpu.shape_transformCenterC (shape.gout, mm.scene.cam.form) 'old: gpu.shape_projectCenterR (shape.gout)
            mm.gpu.shape_performEyetest (shape.gout)

            If shape.gout.clips_nearZ > 0 Then

                mm.gpu.mesh_transformToSpace (shape.mesh, shape.gout) ', scene.cam.form)
                mm.gpu.mesh_transformToCamera (shape.gout, mm.scene.cam.form)
            End If
            s = s + 1
        Loop
        n = n + 1
    Loop
End Sub

'copy faces to scene, select with z-eyetest 
'shape-faces: Z-eyetest and copy to scene faceList 'old: s3_meshFaces_extractToScene()

Public Sub s2_shapes_faceListBuild() 'category: scene_computeObjects()

    Dim n As Int, node As node3
    Dim s As Int, shape As shape3

    mm.scene.reset

    n = 0
    Do While (n < mm.nodes.nodeNum): node = mm.nodes.node(n)
        s = 0
        Do While (s < node.shapeNum): shape = mm.shapes.shape(node.shapeIdx(s))

            If shape.gout.clips_nearZ > 0 Then

                Select Case shape.stype 
                    Case 1
						mm.gpu.shape_transferFaces (mm.scene.bodies, shape.mesh, shape.gout, mm.scene.cam.form, shape.show_radius)
                    Case 2
						mm.gpu.shape_transferFaces (mm.scene.ground, shape.mesh, shape.gout, mm.scene.cam.form, False)
                End Select
            End If
            s = s + 1
        Loop
        n = n + 1
    Loop
End Sub

'sort faceList by depth (= center-distance of from camera)

Public Sub s3_scene_faceListsSort()  'category: scene_computeObjects()

    If mm.scene.bodies.faceNum > 1 Then
        'Array.Sort(mm.scene.bodies.fcz, mm.scene.bodies.fci, 0, mm.scene.bodies.faceNum)

		fcs1 = mm.scene.bodies
		s3_scene_faceList_QuickSort(0, mm.scene.bodies.faceNum - 1)
    End If
End Sub

'QuickSort-Algorithmus. Komplexitaet O(n) ~ n*log(n) (Src: MDIKegel 0.585, modSzene.bas)
'i0 = LBound(Array())
'j0 = UBound(Array())

Private Sub s3_scene_faceList_QuickSort(i0 As Long, j0 As Long)
  
    Dim i As Long, d As Double
	Dim j As Long, p As Double
	Dim k As Long
   
    i = i0: j = j0
    p = fcs1.fcz((i0 + j0) / 2)
	
    'Array aufteilen ->
    Do While (i <= j)
        Do While (fcs1.fcz(i) < p): i = i + 1: Loop
        Do While (fcs1.fcz(j) > p): j = j - 1: Loop
        
        If (i <= j) Then
            'Wertepaare miteinander vertauschen ->
            k = fcs1.fci(i): fcs1.fci(i) = fcs1.fci(j): fcs1.fci(j) = k
            d = fcs1.fcz(i): fcs1.fcz(i) = fcs1.fcz(j): fcs1.fcz(j) = d
            i = i + 1: j = j - 1
        End If
    Loop
  
    'Selbstaufruf mit neuen Grenzen(Rekursion) ->
    If (i0 < j) Then s3_scene_faceList_QuickSort(i0, j)
    If (i < j0) Then s3_scene_faceList_QuickSort(i, j0)
End Sub

'render faces to screen, select with xy-eyetest, utilize xyz-clipping
'aka. s4_sceneFaces_clipAndDisplay(g As Graphics)

Public Sub s4_scene_faceListsDisplay() 'category: scene_displayObjects()

    s4_scene_faceListDisplay (mm.scene.ground)
    s4_scene_faceListDisplay (mm.scene.bodies)
End Sub

Private Sub s4_scene_faceListDisplay(faces As facesCls)

    Dim f As Int
    Dim fc As Int = faces.faceNum-1
    Dim clipXY As Boolean = True 'for test, clipXY might wanna be skipped later

    Do While (fc >= 0)
        f = faces.fci(fc)   'old: If scene.fposZ(f) < 2 Then 'need to check for z-clipping (and consequently, xy-clipping)
        mm.gpu.face_copy (faces, f)

        'gpu.face_clipZ ()
        mm.gpu.face_projectXY ()

        Select Case faces.ftype(f)

            Case 3, 4
                mm.gpu.poly_eyetestXY ()
                If mm.gpu.pseeAny Then 
                    If clipXY Then 
                        mm.gpu.poly_clipY () 'switched with clipX just for esthetical reasons
                        mm.gpu.poly_clipX () 'switched with clipY just for esthetical reasons
                    End If
                    mm.gpu.poly_drawToScreen ()
                End If
            Case 2
                'gpu.line_clipXY_NW ()
                mm.gpu.line_drawToScreen ()
            Case 1
                mm.gpu.circle_drawToScreen()
        End Select
        
        fc = fc - 1
    Loop
End Sub