﻿Type=Class
Version=2.52
@EndOfDesignText@

Sub Class_Globals

	Public useLog As Boolean = False

	Public faceNum, faceMax As Int  'number of faces to be displayed (face-count)
	Public faceNeed As Int          'if more faces needed, resize scene

	Public fx1(), fy1(), fz1() As Float
	Public fx2(), fy2(), fz2() As Float
	Public fx3(), fy3(), fz3() As Float
	Public fx4(), fy4(), fz4() As Float
	Public fx5(), fy5(), fz5() As Float
	    
	Public fci() As Int  'fci: faceRef for sorting; list of face-indices used a references
	Public fcz(), fcx(), fcy() As Double  'fcz: faceDst for sorting; list of face-distances, to compare for depth-sort (z-value of face-center recommended)
	Public fnx(), fny(), fnz() As Float  'transformed face normal-vector x,y,z

	Public ftype() As Int
	Public fmate() As Int
	Public fpnum() As Int
	'Public fposZ() As Int 'must check for clipping? (0:no 1:yes 2:no)
End Sub

Public Sub Initialize() As Boolean

    faceNum = 0
    faceMax = 0
    faceNeed = 0  
End Sub

'set initial scene size, to be called only once at the beginning.
Public Sub init(startSize As Int) 'while not really necessary to give an initial size...
                                      '..it may really speed up the starting process (recommended values: 100-1000) 
    resize(startSize)                 
End Sub

'reset scene facelist, to be called for each frame to begin a new scene.
Public Sub reset()

    If faceNeed > faceMax Then resize(faceNeed)
    faceNum = 0
    faceNeed = 0
End Sub

Private Sub resize(fmax As Int) 'array size adapted to b4a, dumped 'Preserve'

    Dim m As Int = fmax: faceMax = m    'BUG WARNING: For correct array length, m is decreased by 1;
                                        'Reason: As VB-2010 reserves m+1 items (not just m), m.Length would give false results.
    faceNum = 0
    faceNeed = 0

    If faceNum < fmax Then                    
        Dim fx1(m), fy1(m), fz1(m) As Float    
        Dim fx2(m), fy2(m), fz2(m) As Float
        Dim fx3(m), fy3(m), fz3(m) As Float
        Dim fx4(m), fy4(m), fz4(m) As Float
        Dim fx5(m), fy5(m), fz5(m) As Float
        Dim fci(m) As Int
        Dim fcx(m), fcy(m), fcz(m) As Double
        Dim fnx(m), fny(m), fnz(m) As Float
        Dim ftype(m), fmate(m), fpnum(m) As Int ', fposZ(m)
    End If

    If useLog Then show_sizeInfo
End Sub

Private Sub show_sizeInfo()

    Log ("faces.sizeInfo: ")
    Log ("faces.faceNum = " & faceNum)
    Log ("faces.faceMax = " & faceMax)
    Log ("faces.faceNeed = " & faceNeed)
End Sub
