﻿Type=Class
Version=2.52
@EndOfDesignText@

Sub Class_Globals

	Type pointF (x As Float, y As Float)

	Public plane_z1 As Double       'z-value of near clipping-plane
	Public plane_z2 As Double       'z-value of far clipping-plane
	Public lens_scale As Double

	Public win_x1, win_x2 As Double 'x-values of left and right clipping-borders
	Public win_y1, win_y2 As Double 'y-values of upper and lower clipping-borders
	Public win_cx As Double
	Public win_cy As Double

	Private pgi As Int
	Private polygon() As polygon3   'polys: face-copy, z-clipped, x-clipped, y-clipped
	Private pg1, pg2 As polygon3    'references to input-poly, output-poly (deprecated)

	'Private pgz As polygon3   'temp poly only for Z-Clipping
	
	Private path1 As Path		'!NEW! Draw Polys as PolyPath for B4a
	Private pgs() As pointF  	'poly-points for drawing to screen !NEW: TYPE CHANGED
	Private gfx As Canvas 		'System.Drawing.Graphics 'graphics context for drawing to screen

	Public psides As Int        'face number-of-sides (1, 2)
	Public pseeSide As Int      'foreside=1, backside=2
	Public pseeAny As Boolean   'see any side
	Public ptsforeZ As Int

	Private pi As Int           'clipping pointer (point index)
	Private po1, pc1 As point3      'clipping locals
	Private po2, pc2 As point3      'clipping locals

	Private ptype As Int         'face-type
	Private pmate As material3       'face-material (reference to a material, also for later shading)

	Public style As Int
	Public styleNull As Int = 0
	Public styleWires As Int = 1
	Public styleSolid As Int = 2
	Public styleGlass As Int = 3
	Public styleBezier As Int = 4

	Private pen0 As Int 'System.Drawing.Pen
	Private pen1 As Int 'System.Drawing.Pen
	Private pen2 As Int 'System.Drawing.Pen
	
	Private cx As Double
	Private cy As Double
	Private cz As Double
	Private ax0, ax1, ax2, ax3 As Float '3x3 matrix for transformations
	Private ay0, ay1, ay2, ay3 As Float
	Private az0, az1, az2, az3 As Float

	Private z1, z2, z3, z4 As Int
	Private rec1 As Rect 'System.Drawing.Rectangle
	Private mm As mainCls
End Sub

Public Sub Initialize(mm0 As mainCls) As Boolean

	mm = mm0    
	init
End Sub

Public Sub init() 'init polygon clipper and display ->
    
    Dim polygon(4) As polygon3
	Dim pgs(9) As pointF

    polygon(0).Initialize(9): polygon(1).Initialize(9)	'polygon(0) = New polygon3(9): polygon(1) = New polygon3(9)
    polygon(2).Initialize(9): polygon(3).Initialize(9)	'polygon(2) = New polygon3(9): polygon(3) = New polygon3(9)
    
   	po1.Initialize: pc1.Initialize   'po1 = New point3(): pc1 = New point3()
   	po2.Initialize: pc2.Initialize   'po2 = New point3(): pc2 = New point3()

	pen0 = Colors.Black
	pen1 = Colors.Gray
	pen2 = Colors.White
	
	rec1.Initialize(0, 0, 0, 0)  'rec1 = New Rectangle()

    style = styleSolid
    'style = styleWires
End Sub

Public Sub assign_graphics (gfx0 As Canvas)

    gfx = gfx0
End Sub

Public Sub set_fillstyle (style0 As Int)

    style = style0
End Sub

Public Sub face_copy (fcs As facesCls, f As Int)
    
    pgi = 0
    ptype = fcs.ftype(f)
    pmate = mm.materials.material(fcs.fmate(f)) 'old: pgi = pg1: pgo = pg1
    psides = pmate.sides

    pg1 = polygon(pgi)
    pg1.x(0) = fcs.fx1(f): pg1.y(0) = fcs.fy1(f): pg1.z(0) = fcs.fz1(f)
    pg1.x(1) = fcs.fx2(f): pg1.y(1) = fcs.fy2(f): pg1.z(1) = fcs.fz2(f)
    pg1.x(2) = fcs.fx3(f): pg1.y(2) = fcs.fy3(f): pg1.z(2) = fcs.fz3(f)
    pg1.x(3) = fcs.fx4(f): pg1.y(3) = fcs.fy4(f): pg1.z(3) = fcs.fz4(f)
    pg1.x(4) = fcs.fx5(f): pg1.y(4) = fcs.fy5(f): pg1.z(4) = fcs.fz5(f)
    pg1.pnum = fcs.fpnum(f)
End Sub

Public Sub face_copyZ (m As mesh3, g As gout3, f As Int)
    
    Dim p As Int
    Dim z As Double = plane_z1

    pgi = 0
    ptype = m.ftype(f)
    ptsforeZ = 0 

    pg1 = polygon(pgi)
    z1 = 0: p = m.fp1(f): pg1.x(0) = g.pcx(p): pg1.y(0) = g.pcy(p): pg1.z(0) = g.pcz(p): If g.pcz(p) >= z Then z1 = 1
    z2 = 0: p = m.fp2(f): pg1.x(1) = g.pcx(p): pg1.y(1) = g.pcy(p): pg1.z(1) = g.pcz(p): If g.pcz(p) >= z Then z2 = 1
    z3 = 0: p = m.fp3(f): pg1.x(2) = g.pcx(p): pg1.y(2) = g.pcy(p): pg1.z(2) = g.pcz(p): If g.pcz(p) >= z Then z3 = 1
    z4 = 0: p = m.fp4(f): pg1.x(3) = g.pcx(p): pg1.y(3) = g.pcy(p): pg1.z(3) = g.pcz(p): If g.pcz(p) >= z Then z4 = 1

    Select Case ptype
        Case 2: pg1.pnum = 2: ptsforeZ = z1 + z2
        Case 3: pg1.pnum = 3: ptsforeZ = z1 + z2 + z3
        Case 4: pg1.pnum = 4: ptsforeZ = z1 + z2 + z3 + z4
    End Select
End Sub

Public Sub face_clipZ ()
    
    pi = 0  'old: pgi = pg1: pgo = pg2
    pg1 = polygon(pgi)
    pg2 = polygon(pgi+1)

    Select Case pg1.pnum
        Case 2: poline_clipZ (0, 1)
                pg2.pnum = pi
        Case 3: poline_clipZ (0, 1)               'prev: If ptype = 3 Then..
                poline_clipZ (1, 2)
                poline_clipZ (2, 0)
                pg2.pnum = pi
        Case 4: poline_clipZ (0, 1)                'prev: If ptype = 4 Then..  
                poline_clipZ (1, 2)
                poline_clipZ (2, 3)
                poline_clipZ (3, 0)
                pg2.pnum = pi
    End Select
    pgi = pgi + 1
End Sub

Public Sub face_projectXY ()
        
    Dim p As Int = 0 'throwWarning.Untested("face5_projectToWindow")
    Dim z As Double      'If z < zmin then throwException.UnexpectedValue("face5_projectToWindow") 'assume that its >= 1 (!)
    Dim zs As Double
    Dim zmin As Double = plane_z1
    
    pg1 = polygon(pgi)
    Do While (p < pg1.pnum)
        z = pg1.z(p)  ': Debug.Assert(z >= zmin)  'prev: log.assert(z >= zmin)
        zs = lens_scale / z      
        pg1.x(p) = pg1.x(p) * zs
        pg1.y(p) = pg1.y(p) * zs
        p = p + 1
    Loop
End Sub

'Public Sub polygon_testBackface (ByRef poly As GeoScene.Polygon, ByRef visible As Boolean)
Public Sub poly_eyetestXY () 'aka. polyTest_backface, poly_eyeTest, poly_seeTest, poly_visioTest

    Dim s As Float = 0 'assume: see foreside
    
    pg1 = polygon(pgi)
    If pg1.pnum > 2 Then 'calulate d = v1 x v2 (2d-backface-test)
        Dim v1x As Float = pg1.x(0) - pg1.x(1)
        Dim v1y As Float = pg1.y(0) - pg1.y(1)
        Dim v2x As Float = pg1.x(2) - pg1.x(1)
        Dim v2y As Float = pg1.y(2) - pg1.y(1)
        s = v1x * v2y - v1y * v2x  
    End If

    pseeSide = 1
    If (s < 0) Then pseeSide = 2
    pseeAny = (pseeSide = 1 OR psides = 2)
End Sub

Public Sub line_clipXY_NOTWORKING ()

    Dim i As Int = 0: pi = 0 
    
    pg1 = polygon(pgi)
    pg2 = polygon(pgi+1)

    poline_clipY (0, 1)

    pg2.pnum = pi: pgi = pgi + 1 

    pg1 = polygon(pgi)
    pg2 = polygon(pgi+1)

    poline_clipX (0, 1)

    pg2.pnum = pi: pgi = pgi + 1
End Sub


'aka. polygon_clipVsWindowY()
Public Sub poly_clipY ()

    Dim i As Int = 0: pi = 0  'pgi = pg3: pgo = pg4      
    
    pg1 = polygon(pgi)
    pg2 = polygon(pgi+1)

    Do While (i < pg1.pnum-1)
        poline_clipY (i, i+1): i = i + 1
    Loop: poline_clipY (i, 0)

    pg2.pnum = pi: pgi = pgi + 1
End Sub

'aka. polygon_clipVsWindowX()
Public Sub poly_clipX ()

    Dim i As Int = 0: pi = 0  'pgi = pg2: pgo = pg3

    pg1 = polygon(pgi)
    pg2 = polygon(pgi+1)

    Do While (i < pg1.pnum-1)
        poline_clipX (i, i+1): i = i + 1
    Loop: poline_clipX (i, 0)
    
    pg2.pnum = pi: pgi = pgi + 1
End Sub

Public Sub poly_drawToScreen ()

    Dim p As Int 'throwWarning.Untested("polygon_drawToWindow")

    'If pseeSide = 1 Then pen1.Color = Color.FromArgb(pmate.sideA.c32)  
    'If pseeSide = 2 Then pen1.Color = Color.FromArgb(pmate.sideB.c32) 'Color.Black
    If pseeSide = 1 Then pen1 = pmate.sideA.c32  
    If pseeSide = 2 Then pen1 = pmate.sideB.c32 'prev: Color.Black	
	
    pg1 = polygon(pgi)
 
    If pg1.pnum > 2 Then
        'ReDim Preserve pgs(pg1.pnum-1) 'poly.p.CopyTo(pts, 0)
		'Dim pgs(pg1.pnum)

        For p = 0 To pg1.pnum-1   'f5.p.CopyTo(Me.face(f).p, 0) 'alt.: For i = 0 to f5.pCnt - 1: Me.face(f).p(i) = f5.p(i): Next i
            pgs(p).x = win_cx + pg1.x(p) 
            pgs(p).y = win_cy - pg1.y(p)
        Next

        Select Case style
            Case styleWires: path_drawToScreenW(pen0) 'gfx.DrawPolygon(pen3, pgs)
            Case styleSolid: path_drawToScreenS(pen1) 'gfx.FillPolygon(pen1.Brush, pgs)
        End Select
    End If 
End Sub


Private Sub path_drawToScreenS (pcolor As Int) 'NEW B4a-Adapted: Draw Filled Polygon as open path
	
	Dim p As Int: path1.Initialize(pgs(0).x, pgs(0).y)
	
	For p = 1 To pg1.pnum-1
		path1.LineTo(pgs(p).x, pgs(p).y)
	Next
	gfx.DrawPath (path1, pcolor, True, 0) 
End Sub

Private Sub path_drawToScreenW (pcolor As Int) 'NEW B4a-Adapted: Draw Wireframe Polygon as closed path
	
	Dim p As Int: path1.Initialize(pgs(0).x, pgs(0).y)
	
	For p = 1 To pg1.pnum-1
		path1.LineTo(pgs(p).x, pgs(p).y): Next
	path1.LineTo(pgs(0).x, pgs(0).y)
	
	gfx.DrawPath (path1, pcolor, False, 0) 
End Sub

Public Sub line_drawToScreen ()

    Dim p As Int 'throwWarning.Untested("polygon_drawToWindow")

    pg1 = polygon(pgi)

    If pg1.pnum = 2 Then
        'ReDim Preserve pgs(2)
        'pen1.Color = Color.FromArgb(pmate.sideA.c32)  
		pen1 = pmate.sideA.c32

        For p = 0 To 1
            pgs(p).x = win_cx + pg1.x(p) 
            pgs(p).y = win_cy - pg1.y(p)
        Next
 
        If pg1.pnum = 2 Then
            'pen1.Width = pmate.width
            'gfx.DrawLine (pen1, pgs(0), pgs(1))
			gfx.DrawLine (pgs(0).x, pgs(0).y, pgs(1).x, pgs(1).y, pen1, pmate.width)
        End If
    End If
End Sub

Public Sub circle_drawToScreen ()

    Dim rx As Float = Abs(pg1.x(1) - pg1.x(0))
    Dim ry As Float = Abs(pg1.y(1) - pg1.y(0))
    Dim x As Float = win_cx + pg1.x(0) '- rx
    Dim y As Float = win_cy - pg1.y(0) '- ry
    'Dim w As Float = rx * 2
    'Dim h As Float = ry * 2
	Dim r As Float = rx

    pg1 = polygon(pgi)
    pen1 = pmate.sideA.c32 'Color.FromArgb(pmate.sideA.c32)                      
    'pen1.Width = pmate.width
    pen2 = pmate.sideB.c32 'Color.FromArgb(pmate.sideB.c32)
    'gfx.FillEllipse (pen1.Brush, x, y, w, h)
    'gfx.DrawEllipse (pen2, x, y, w, h)
	
    gfx.DrawCircle (x, y, r, pen1, True, 0)  'alt: pmate.width
    gfx.DrawCircle (x, y, r, pen2, False, 0) 'alt: pmate.width
End Sub
'---------------------------------------------------------------------------------------------------------------------------------------------------

Private Sub poline_clipZ (p1 As Int, p2 As Int)

    Dim cc As Int = 22  'assume line in front of z-plane (no clipping)
    Dim s1 As Double = 0    's1 = x1-scaling
    Dim dx As Double = pg1.x(p2) - pg1.x(p1) 
    Dim dy As Double = pg1.y(p2) - pg1.y(p1) 
    Dim dz As Double = pg1.z(p2) - pg1.z(p1)
    Dim lnp As Boolean = (Abs(dz) > 0.0001) '? Is line not parallel to z-plane

    'analyse intersection: calculate clipping case ->
    If pg1.z(p1) < plane_z1 Then cc = cc - 10
    If pg1.z(p2) < plane_z1 Then cc = cc - 1
        
    'if intersection happens, calculate clipping points. Alternative: If Not (cc = 11 or cc = 22) Then 
    If cc = 12 OR cc = 21 Then              
        If lnp Then s1 = (plane_z1 - pg1.z(p1)) / dz
        cx = pg1.x(p1) + dx * s1
        cy = pg1.y(p1) + dy * s1
        cz = plane_z1                
    End If

    Select Case cc
        Case 22: pg2.x(pi) = pg1.x(p1) 'If cc = 22 Then f5.p(i) = p1: i += 1
                 pg2.y(pi) = pg1.y(p1)
                 pg2.z(pi) = pg1.z(p1): pi = pi + 1
        Case 12: pg2.x(pi) = cx 'If cc = 12 Then f5.p(i) = c1: i += 1  
                 pg2.y(pi) = cy
                 pg2.z(pi) = cz: pi = pi + 1
        Case 21: pg2.x(pi) = pg1.x(p1): pg2.x(pi+1) = cx  'If cc = 21 Then f5.p(i) = p1: f5.p(i+1) = c1: i += 2
                 pg2.y(pi) = pg1.y(p1): pg2.y(pi+1) = cy
                 pg2.z(pi) = pg1.z(p1): pg2.z(pi+1) = cz: pi = pi + 2
    End Select  
End Sub

'Clips a Line vs. the vertical Window borders, left(x1) and right(x2) ->
Private Sub poline_clipX (p1 As Int, p2 As Int)

    po1.x = pg1.x(p1): pc1.x = po1.x  'Static c1 As GeoPlane.Point: c1 = p1
    po1.y = pg1.y(p1): pc1.y = po1.y  'Static c2 As GeoPlane.Point: c2 = p2
    po2.x = pg1.x(p2): pc2.x = po2.x  'Static c1 As GeoPlane.Point: c1 = p1
    po2.y = pg1.y(p2): pc2.y = po2.y  'Static c2 As GeoPlane.Point: c2 = p2

    'Dim i As Integer: i = pi
    Dim cc As Int = 22 'assume line is inside window LR-borders
    Dim s1 As Double = 0 's1 = x1-scale. Do pre-caculations here if intersection is the usual case
    Dim s2 As Double = 0 's2 = x2-scale. Do pre-calculations here if intersection is the usual case
    Dim dx As Double = po2.x - po1.x
    Dim dy As Double = po2.y - po1.y
    Dim nv As Boolean = (Abs(dx) > 0.0001) '? Is line not vertical (LNV)

    'calculate intersection/clipping case
    If po1.x < win_x1 Then cc = cc - 10
    If po1.x > win_x2 Then cc = cc + 10
    If po2.x < win_x1 Then cc = cc - 1
    If po2.x > win_x2 Then cc = cc + 1
        
    'if intersection happens, calculate clipping/segment points
    If Not (cc = 11 OR cc = 22 OR cc = 33) Then              
        If nv Then s1 = (win_x1 - po1.x) / dx
        If nv Then s2 = (win_x2 - po1.x) / dx
        pc1.y = po1.y + dy * s1: pc1.x = win_x1
        pc2.y = po1.y + dy * s2: pc2.x = win_x2                
    End If

    If cc = 12 Then poly_copyOne (pc1)
    If cc = 13 Then poly_copyTwo (pc1, pc2)    
    If cc = 21 Then poly_copyTwo (po1, pc1)
    If cc = 22 Then poly_copyOne (po1)
    If cc = 23 Then poly_copyTwo (po1, pc2)
    If cc = 31 Then poly_copyTwo (pc2, pc1)
    If cc = 32 Then poly_copyOne (pc2)
    'pi = i   
End Sub

 'Clips a Line vs. the horizontal Window borders, up(y1) and down(y2) ->
Private Sub poline_clipY (p1 As Int, p2 As Int)

    po1.x = pg1.x(p1): pc1.x = po1.x  'Static c1 As GeoPlane.Point: c1 = p1
    po1.y = pg1.y(p1): pc1.y = po1.y  'Static c2 As GeoPlane.Point: c2 = p2
    po2.x = pg1.x(p2): pc2.x = po2.x  'Static c1 As GeoPlane.Point: c1 = p1
    po2.y = pg1.y(p2): pc2.y = po2.y  'Static c2 As GeoPlane.Point: c2 = p2

    'Static i As Integer: i = Me.i
    Dim cc  As Int = 22 'assume line is inside window UD-borders
    Dim s1  As Double = 0 's1 = x1-scale, put pre-calculations here, if -clipping- is the usual case
    Dim s2 As Double = 0 's2 = x2-scale, put pre-calculations here, if -clipping- is the usual case
    Dim dx As Double
    Dim dy As Double
    Dim nh As Boolean '? Is line not horizontal (LNH)
                  
    'calculate clipping case ->
    If po1.y < win_y1 Then cc = cc - 10
    If po1.y > win_y2 Then cc = cc + 10
    If po2.y < win_y1 Then cc = cc - 1
    If po2.y > win_y2 Then cc = cc + 1

    'If cc = 12 or cc = 13 or cc = 23 or cc = 21 or cc = 31 or cc = 32 Then 'calcutate c1, c2
    If Not (cc = 11 OR cc = 22 OR cc = 33) Then
        'd0 = Math.Abs(p2.y - p1.y)
        dx = po2.x - po1.x
        dy = po2.y - po1.y
        nh = (Abs(dy) > 0.0001)
        If nh Then s1 = (win_y1 - po1.y) / dy
        If nh Then s2 = (win_y2 - po1.y) / dy
        pc1.x = po1.x + dx * s1: pc1.y = win_y1
        pc2.x = po1.x + dx * s2: pc2.y = win_y2                 
    End If

    If cc = 22 Then poly_copyOne (po1)
    If cc = 12 Then poly_copyOne (pc1)
    If cc = 23 Then poly_copyTwo (po1, pc2)
    If cc = 13 Then poly_copyTwo (pc1, pc2)         
    If cc = 21 Then poly_copyTwo (po1, pc1)
    If cc = 32 Then poly_copyOne (pc2)
    If cc = 31 Then poly_copyTwo (pc2, pc1)                   
End Sub

Private Sub poly_copyOne (p1 As point3)
    
    pg2.x(pi) = p1.x
    pg2.y(pi) = p1.y: pi = pi + 1
End Sub

Private Sub poly_copyTwo (p1 As point3, p2 As point3)
    
    pg2.x(pi) = p1.x: pg2.x(pi+1) = p2.x
    pg2.y(pi) = p1.y: pg2.y(pi+1) = p2.y: pi = pi + 2 
End Sub


'------------ GPU Transformer Functions ----------------->

'Public Sub setCameraTransform(xfm As xform3)
'End Sub

'f = shape input-matrix, m = node transform-matrix, g = shape output-matrix
Public Sub shape_transformMatrix (f As xform3, m As xform3, g As gout3)

    ax0 = f.ax(0) - m.ax(0): ax1 = f.ax(1): ax2 = f.ax(2): ax3 = f.ax(3)
    ay0 = f.ay(0) - m.ay(0): ay1 = f.ay(1): ay2 = f.ay(2): ay3 = f.ay(3)
    az0 = f.az(0) - m.az(0): az1 = f.az(1): az2 = f.az(2): az3 = f.az(3)

    g.ax(0) = ax0 * m.ax(1) + ay0 * m.ay(1) + az0 * m.az(1)
    g.ay(0) = ax0 * m.ax(2) + ay0 * m.ay(2) + az0 * m.az(2)
    g.az(0) = ax0 * m.ax(3) + ay0 * m.ay(3) + az0 * m.az(3)

    g.ax(1) = ax1 * m.ax(1) + ax2 * m.ax(1) + ax3 * m.ax(1)
    g.ay(1) = ay1 * m.ay(1) + ay2 * m.ay(1) + ay3 * m.ay(1)
    g.az(1) = az1 * m.az(1) + az2 * m.az(1) + az3 * m.az(1)

    g.ax(2) = ax1 * m.ax(2) + ax2 * m.ax(2) + ax3 * m.ax(2)
    g.ay(2) = ay1 * m.ay(2) + ay2 * m.ay(2) + ay3 * m.ay(2)
    g.az(2) = az1 * m.az(2) + az2 * m.az(2) + az3 * m.az(2)

    g.ax(3) = ax1 * m.ax(3) + ax2 * m.ax(3) + ax3 * m.ax(3)
    g.ay(3) = ay1 * m.ay(3) + ay2 * m.ay(3) + ay3 * m.ay(3)
    g.az(3) = az1 * m.az(3) + az2 * m.az(3) + az3 * m.az(3)
End Sub

'transform Points and Normals to Space
Public Sub mesh_transformToSpace (m As mesh3, g As gout3)

    Dim p As Int = 0
    Dim f As Int = 0
    Dim x, y, z As Double

    'mesh_transformPointsS (m As mesh3, g As gout3) 'form = camera-pre-transformed xform of shape
    Do While (p < m.pnum)
        x = m.px(p) 'load shape.point ->
        y = m.py(p)
        z = m.pz(p)  
        g.px(p) = g.ax(0) + x * g.ax(1) + y * g.ay(1) + z * g.az(1)  'transform to space point ->
        g.py(p) = g.ay(0) + x * g.ax(2) + y * g.ay(2) + z * g.az(2) 
        g.pz(p) = g.az(0) + x * g.ax(3) + y * g.ay(3) + z * g.az(3) 
        p = p + 1
    Loop

    'mesh_transformNormalsS (m As mesh3, g As gout3) 'transforms face-center, face-normal and face-sidecount
    Do While (f < m.fnum)
        x = m.fcx(f) 'load face center-point ->
        y = m.fcy(f)
        z = m.fcz(f)
        g.fcx(f) = x * g.ax(1) + y * g.ay(1) + z * g.az(1) + g.ax(0) 'transform to space.face.center ->
        g.fcy(f) = x * g.ax(2) + y * g.ay(2) + z * g.az(2) + g.ay(0)
        g.fcz(f) = x * g.ax(3) + y * g.ay(3) + z * g.az(3) + g.az(0)
        x = m.fnx(f) 'load face normal-vector (eye-vector) ->
        y = m.fny(f)
        z = m.fnz(f)
        g.fnx(f) = x * g.ax(1) + y * g.ay(1) + z * g.az(1) 'transform to space normal-vector ->
        g.fny(f) = x * g.ax(2) + y * g.ay(2) + z * g.az(2) 
        g.fnz(f) = x * g.ax(3) + y * g.ay(3) + z * g.az(3) 
        x = m.fux(f) 'load face up-vector ->
        y = m.fuy(f)
        z = m.fuz(f)
        g.fux(f) = x * g.ax(1) + y * g.ay(1) + z * g.az(1) 'transform to space up-vector ->
        g.fuy(f) = x * g.ax(2) + y * g.ay(2) + z * g.az(2) 
        g.fuz(f) = x * g.ax(3) + y * g.ay(3) + z * g.az(3) 

        g.fsides(f) = mm.materials.material(m.fmate(f)).sides
        f = f + 1
    Loop
End Sub

'transform Points to Camera
Public Sub mesh_transformToCamera (g As gout3, cfm As xform3) 'form = camera-pre-transformed xform of shape

    Dim p As Int = 0
    Dim x, y, z As Double

    Do While (p < g.pnum)
        x = g.px(p) - cfm.ax(0) 'load shape.point (transformed) ->
        y = g.py(p) - cfm.ay(0)
        z = g.pz(p) - cfm.az(0) 
        g.pcx(p) = x * cfm.ax(1) + y * cfm.ay(1) + z * cfm.az(1) 'transform to cam point ->
        g.pcy(p) = x * cfm.ax(2) + y * cfm.ay(2) + z * cfm.az(2)
        g.pcz(p) = x * cfm.ax(3) + y * cfm.ay(3) + z * cfm.az(3)
        p = p + 1
    Loop
End Sub

'transform and project: shape center, hull-radius
Public Sub shape_transformCenterC (g As gout3, cfm As xform3) 'form = camera-pre-transformed xform of shape

    Dim p As Int = 0 'throwWarning.Untested("face5_projectToWindow")
    Dim zs As Double = 0
    Dim zmin As Double = plane_z1 'currently unused(!)
    Dim x, y, z As Double

    x = g.ax(0) - cfm.ax(0) 'load shape.position (transformed) ->
    y = g.ay(0) - cfm.ay(0)
    z = g.az(0) - cfm.az(0) 
    g.ax0 = x * cfm.ax(1) + y * cfm.ay(1) + z * cfm.az(1) 'transform to cam position ->
    g.ay0 = x * cfm.ax(2) + y * cfm.ay(2) + z * cfm.az(2)
    g.az0 = x * cfm.ax(3) + y * cfm.ay(3) + z * cfm.az(3)

    'z = g.az0 'If z < zmin then throwException.UnexpectedValue("face5_projectToWindow") 'assume that its >= 1 (!)
    If g.az0 > 0.0001 Then zs = lens_scale / g.az0

    g.pro_ax0 = g.ax0 * zs
    g.pro_ay0 = g.ay0 * zs
    g.pro_az0 = g.az0
    g.pro_radius = g.hrad_outer * zs 'note: max(lens_scaleX, lens_scaleY) is more correct!
End Sub

'Public Sub shape_projectCenterR_OLD (g As gout3)
'End Sub

'aka. seeTest..()
Public Sub shape_performEyetest (gout As gout3)

    Dim r1 As Double = gout.hrad_outer  'shape_visioTest_nearZ (gout As gout3) ->
    Dim cnz As Int = 1              'assume nearZ intersection

    If (gout.az0 - r1) > plane_z1 Then cnz = 2 'before nearZ (visible possibly)
    If (gout.az0 + r1) < plane_z1 Then cnz = 0 'behind nearZ (invisible)

    gout.clips_nearZ = cnz
   
    Dim r2 As Float = gout.pro_radius      'shape_visioTest_winXY (gout As gout3) ->
    Dim x1 As Float = gout.pro_ax0 - r2
    Dim x2 As Float = gout.pro_ax0 + r2
    Dim y1 As Float = gout.pro_ay0 - r2
    Dim y2 As Float = gout.pro_ay0 + r2
    Dim cwx As Int = 1                  'assume winX intersection
    Dim cwy As Int = 1                  'assume winY intersection
    
    If x2 < win_x1 Then cwx = 0                 'left from winX1 (invisible)
    If x1 > win_x2 Then cwx = 0                 'right from winX2 (invisible)
    If x1 > win_x1 AND x2 < win_x2 Then cwx = 2 'between winX1 and winX2 (visible)

    If y2 < win_y1 Then cwy = 0                 'left from winY1 (invisible)
    If y1 > win_y2 Then cwy = 0                 'right from winY2 (invisible)
    If y1 > win_y1 AND y2 < win_y2 Then cwy = 2 'between winY1 and winY2 (visible)

    gout.clips_winX = cwx
    gout.clips_winY = cwy
End Sub

'Main steps of shape_transferFaces():
'1. re-create cam-normal, only z-value is needed for face-seetest (rest of cam-normal can be dumped, no need to store)
'2. copy face points to scene
'3. copy space-normal to scene for later face-shading   
'4. create face-center for z-sorting (again only z-value is needed, but maybe the distance is better for sorting, so leave center-calculation in)
'5. copy type and material to scene 

Public Sub shape_transferFaces (fcs As facesCls, m As mesh3, g As gout3, cfm As xform3, showHull As Boolean)

    Dim f1 As Int = 0
    Dim f2 As Int = fcs.faceNum
    Dim x1, x2 As Double
    Dim y1, y2 As Double
    Dim z As Double  
    Dim pn As Int
    Dim fsee As Boolean
    
    fcs.faceNeed = fcs.faceNeed + m.fnum+1
    If fcs.faceNeed > fcs.faceMax Then Return
       
    If showHull Then
        If g.az0 >= plane_z1 Then
            fcs.fcx(f2) = g.ax0: fcs.fx1(f2) = g.ax0: fcs.fx2(f2) = g.ax0 - g.hrad_outer * 1.1
            fcs.fcy(f2) = g.ay0: fcs.fy1(f2) = g.ay0: fcs.fy2(f2) = g.ay0 + g.hrad_outer * 1.1
            fcs.fcz(f2) = g.az0: fcs.fz1(f2) = g.az0: fcs.fz2(f2) = g.az0
            fcs.ftype(f2) = 1
            fcs.fmate(f2) = mm.materials.iHullSphere
            fcs.fpnum(f2) = 2
            fcs.fci(f2) = f2: f2 = f2 + 1
        End If
    End If

    Do While (f1 < m.fnum)
    
        x1 = g.fnx(f1) 'load space.normal ->
        y1 = g.fny(f1)
        z1 = g.fnz(f1) 
        x2 = cfm.ax(0) - g.fcx(f1) 
        y2 = cfm.ay(0) - g.fcy(f1)
        z2 = cfm.az(0) - g.fcz(f1) 
        z = x1 * x2 + y1 * y2 + z1 * z2

        fsee = (z <= 0 OR g.fsides(f1) = 2)  'prev: fsee And fadd 'g.fnz() replaced gpu.visionTest_normalZ (shape.gout, f1)
        If fsee Then 'If face.z points to eye OR has two sides, Then copy face (fsee=true)

            face_copyZ(m, g, f1) 'copy cam-face to gpu, do z-cliptest
            pn = mm.gpu.ptsforeZ
    
            If pn > 0 Then 
                If pn < pg1.pnum Then
                    face_clipZ: pg1 = pg2
                End If
                
                fcs.fx1(f2) = pg1.x(0): fcs.fy1(f2) = pg1.y(0): fcs.fz1(f2) = pg1.z(0) 'copy face.cam-points ->
                fcs.fx2(f2) = pg1.x(1): fcs.fy2(f2) = pg1.y(1): fcs.fz2(f2) = pg1.z(1)
                fcs.fx3(f2) = pg1.x(2): fcs.fy3(f2) = pg1.y(2): fcs.fz3(f2) = pg1.z(2)
                fcs.fx4(f2) = pg1.x(3): fcs.fy4(f2) = pg1.y(3): fcs.fz4(f2) = pg1.z(3)
                fcs.fx5(f2) = pg1.x(4): fcs.fy5(f2) = pg1.y(4): fcs.fz5(f2) = pg1.z(4)
                    
                fcs.fnx(f2) = g.fnx(f1)     'just copy face.space-normal (for shading) ->
                fcs.fny(f2) = g.fny(f1)
                fcs.fnz(f2) = g.fnz(f1)
                                            
                x1 = g.fcx(f1) - cfm.ax(0)  'xform and copy face.cam-center ->
                y1 = g.fcy(f1) - cfm.ay(0)  'use z-value(fcz)* or xyz-distance(fcr) for depth-sorting. (*used)
                z1 = g.fcz(f1) - cfm.az(0)
                fcs.fcx(f2) = x1 * cfm.ax(1) + y1 * cfm.ay(1) + z1 * cfm.az(1)
                fcs.fcy(f2) = x1 * cfm.ax(2) + y1 * cfm.ay(2) + z1 * cfm.az(2)
                fcs.fcz(f2) = x1 * cfm.ax(3) + y1 * cfm.ay(3) + z1 * cfm.az(3)
                
                fcs.ftype(f2) = m.ftype(f1) 'copy type and material -> 
                fcs.fmate(f2) = m.fmate(f1)
                fcs.fpnum(f2) = pg1.pnum    'alt: fn(), fsize(), fpts(), fptn(), flng()
                fcs.fci(f2) = f2

                f2 = f2 + 1
            End If
        End If
        f1 = f1 + 1
    Loop
    fcs.faceNum = f2
End Sub
