﻿Type=Class
Version=2.52
@EndOfDesignText@

Sub Class_Globals

    Public builder   As builderCls
    Public meshlab   As meshLabs   'aka. prev: meshfac, meshFactory

    Public colors1   As colorsCls
    Public materials As materialsCls

    Public meshes    As meshesCls
    Public nodes     As nodesCls
    Public shapes    As shapesCls

    Public scene     As sceneCls
    Public engine    As engineCls
    Public gpu       As gpuCls
    Public camera1   As camera3
    Public window    As window3
    Public input     As inputCls

	Public screen As screenCls	'NEW	
	Public sounds As soundsCls
	
	Private act As Activity
	Private screenIdt As Boolean = False
	Private systemIdt As Boolean = False
	
	Private aCounter As Int 
End Sub

Public Sub Initialize(a As Activity) As Boolean

	Log ("----------------")
	init_screen(a)
	init_system
	
	aCounter = 0
End Sub

Public Sub init_screen(a As Activity)
 
 	If screenIdt = False Then

		Log ("init_screen()...")

		screen.Initialize(a, Me)
		
        Log ("init_screen() done.")
		screenIdt = True
	End If
End Sub

Public Sub init_system()

	Dim ok As Int
	Dim s As String

    If systemIdt = False Then

        Log ("init_system()...")
		Log ("A. Build Sounds...")
			
		sounds.Initialize(2)
		sounds.load_sounds(True) 
		sounds.start_sounds(True)
		'If sounds.loadOk = False Then ...
		'If sounds.startOk = False Then ...
		
        Log ("B. Build Components...")
		
	   	builder.Initialize(Me)
        builder.create_components
        meshlab.Initialize(Me)

        'forms_relocate("landscape")
        'window.setView(fmMain.pic1, 0.8, 0.8)
        'window.setContext(fmMain.pic1, fmMain.pic1_bitmap, fmMain.pic1_graphics)

        reset_windows
        reset_controls
   
        builder.build_component(builder.cColors)
        builder.build_component(builder.cMaterials)
        builder.build_component(builder.cMeshes)
        builder.build_component(builder.cNodes)
        builder.build_component(builder.cScene)
        builder.build_component(builder.cCamera)
                                            
        'camera.assignWindow (window)
        'engine.s0_prepare (camera, fmMain.pic1_graphics)

        reload_graphics

        camera1.form.moveTo (-100, 180, -660)
		camera1.form.rotate (15, 9, 0)
        camera1.setPlanes (10, 1000)
       
        Log ("init_system() done.")
        systemIdt = True
    End If
End Sub

Public Sub reset_windows()

    'forms_relocate("landscape")
	'prev: mm.window.setContext(fmMain.pic1, fmMain.pic1_bitmap, fmMain.pic1_graphics)
	'prev: mm.window.setView(fmMain.pic1, 0.9, 0.9)

   	window.setContext(screen.pan, screen.gfx) 'must be called first 	
	window.setViewbox(0.88, 0.9) 			  'must be called secondly
End Sub

Public Sub reset_controls()

    input.control.recenter(window)
End Sub

Public Sub reload_graphics()
    
    camera1.assignWindow (window)
    engine.s0_prepare (camera1, screen.gfx)
End Sub

Public Sub screen_refresh

	input_cameraControl
	nodes_move
	shapes_modify
	view_refresh
	'show_watchValues
End Sub

Public Sub nodes_move()

    'shapes.shape(0).form.rotate(-0.66*0, 1.99, -1.55*0)
    nodes.node(1).form.rotate(0.0, -1.2, 0.44)
    'nodes.node(0).form.rotate(-0.12, 0.15, 0.13)
End Sub

Public Sub shapes_modify()

	Dim m As mesh3 = shapes.shape(4).mesh
	Dim p As Int
	Dim x, y, z As Float
	Dim r As Double
	Dim a As Double = aCounter 
		
	For p = 0 To m.pnum-1
	
		x = m.px(p)
		z = m.pz(p)
		If Abs(x) < 255 AND Abs(z) < 255 Then 
			r = Sqrt(x*x + z*z)
			y = Sin(r*0.04 + a*0.04) * 8
			m.py(p) = y
		End If
	Next
	aCounter = aCounter + 1
End Sub

Public Sub view_refresh() 'draws background lines first

    view_background_refresh (window) '(fmMain.pic1_graphics, window)
    view_scene_rerender (window) 	 '(fmMain.pic1_graphics)
	view_overlay_refresh (window)	 'prev: view_foreground_refresh (window)
	view_show (window)				 'prev: view_bitmap_copy (window)
End Sub

Public Sub show_watchValues()

    Log ("scene.bodies.faceNum  = " & scene.bodies.faceNum)
    Log ("scene.bodies.faceNeed = " & scene.bodies.faceNeed)
    Log ("scene.bodies.faceMax  = " & scene.bodies.faceMax)
    Log ("scene.ground.faceNum  = " & scene.ground.faceNum)
    Log ("scene.ground.faceNeed = " & scene.ground.faceNeed)
    Log ("scene.ground.faceMax  = " & scene.ground.faceMax)
End Sub


Private Sub view_background_refresh(w As window3)

    'w.gfx.Clear(Colors.RGB(240, 240, 240)) 'set back color
	w.gfx.DrawColor(Colors.RGB(240, 240, 240)) 'B4a replacement 
End Sub

Private Sub view_scene_rerender(w As window3)

    engine.s1_shapes_transformTest()
    engine.s2_shapes_faceListBuild()
    engine.s3_scene_faceListsSort()
    engine.s4_scene_faceListsDisplay()
End Sub

'Private Sub view_foreground_refresh(w As window3)
Private Sub view_overlay_refresh(w As window3)

    Dim xc As Int = w.centerX
    Dim yc As Int = w.centerY
    Dim xs As Int = w.sizeX
    Dim ys As Int = w.sizeY
    Dim xd As Int = xs / 48
    Dim yd As Int = ys / 30
    Dim x1 As Int = xc + w.x1
    Dim x2 As Int = xc + w.x2
    Dim y1 As Int = yc + w.y1
    Dim y2 As Int = yc + w.y2
    Dim cs As control2 = input.control

    view_overlay_showFps (w)
    
    w.gfx.DrawLine (x1, 0, x1, ys, w.pen1, 0)
    w.gfx.DrawLine (x2, 0, x2, ys, w.pen1, 0)
    w.gfx.DrawLine (0, y1, xs, y1, w.pen1, 0)
    w.gfx.DrawLine (0, y2, xs, y2, w.pen1, 0)
	
	w.gfx.DrawLine (xc-xd*2, yc, xc-xd, yc, w.pen0, 0)
    w.gfx.DrawLine (xc+xd+1, yc, xc+xd*2+1, yc, w.pen0, 0)
	w.gfx.DrawLine (xc, yc-yd*2, xc, yc-yd, w.pen0, 0)
    w.gfx.DrawLine (xc, yc+yd+1, xc, yc+yd*2+1, w.pen0, 0)

    If cs.buttonLeft OR cs.buttonRight Then
        If cs.buttonLeft Then 
			w.gfx.DrawCircle (cs.px0, cs.py0, 14, w.pen4, False, 4)
        End If
        If cs.buttonRight Then 
			w.gfx.DrawCircle (cs.px0, cs.py0, 20, w.pen5, False, 4)
        End If
    End If
  
	w.gfx.DrawCircle (cs.px1, cs.py1, 24, w.pen1, False, 0)  	'w.gfx.DrawEllipse (w.pen1, w.rec0)  
	w.gfx.DrawLine (cs.px0, cs.py0, cs.px1, cs.py1, w.pen2, 0)  'w.gfx.DrawLine (w.pen1, cs.px0, cs.py0, cs.px1, cs.py1)
	w.gfx.DrawCircle (cs.px3, cs.py3, 24, w.pen1, False, 0)  
	w.gfx.DrawLine (cs.px2, cs.py2, cs.px3, cs.py3, w.pen2, 0)

    'reset_ellipse (w.rec0, cs.px1, cs.py1, 14, 14)
	Select Case cs.active1
		Case 0: w.gfx.DrawCircle (cs.px0, cs.py0, 18, w.pen1, False, 0) 'w.gfx.DrawEllipse (w.pen0, w.rec0)
    	Case 1: w.gfx.DrawCircle (cs.px0, cs.py0, 22, w.pen1, False, 0) 'w.gfx.DrawEllipse (w.pen3, w.rec0)
	End Select
	Select Case cs.active2
		Case 0: w.gfx.DrawCircle (cs.px2, cs.py2, 18, w.pen1, False, 0)
    	Case 1: w.gfx.DrawCircle (cs.px2, cs.py2, 22, w.pen1, False, 0)
	End Select
End Sub


Private Sub view_overlay_showFps(w As window3)

	Dim f As frameCls = w.frame: f.now = f.now + 1
	
    If f.show Then
		f.show = False: f.rate = f.now - f.last: f.last = f.now
    End If
	f.rateS = f.rate
	w.gfx.DrawText (f.rateS, 4, w.fontsize1+4, w.fontface1, w.fontsize1, Colors.Black, "LEFT")
End Sub

Private Sub view_show(w As window3)

    'w.pic.Image = w.bmp 'update view => copy bitmap to picture
	w.pic.Invalidate
End Sub

Public Sub input_cameraControl()

    Dim cs As control2 = input.control
    Dim fm As xform3 = camera1.form
    Dim sx1, mx1 As Float 'stick1 and mouse movement.x
    Dim sy1, my1 As Float 'stick1 and mouse movement.y
    Dim sx3, mx3 As Float 'stick2 and mouse movement.x
    Dim sy3, my3 As Float 'stick2 and mouse movement.y
    Dim fss As Float      'speedscale, should depend on actual framerate (but doesn't^)
	Dim vol As Float	  'sound volume (0..1)
	Dim rate As Float     'sound rate (0..2) (requires sound restart?)
	Dim wscx As Float = 960 / window.sizeX  'set 960px screen width as unit-scale
	Dim wscy As Float = 600 / window.sizeY  'set 600px screen heigth as unit-scale
	Dim mscx As Float = 1.5  'mouse movement scale.x
	Dim mscy As Float = 1.5  'mouse movement scale.y
		
	
    If window.render_speed = 1 Then fss = 2 
    If window.render_speed = 2 Then fss = 1

	'compute stick 1 and 2 amplitudes, window-normalized ->
	sx1 = (cs.px1 - cs.px0) * wscx
    sy1 = (cs.py1 - cs.py0) * wscy
  	sx3 = (cs.px3 - cs.px2) * wscx
    sy3 = (cs.py3 - cs.py2) * wscy

    Select Case cs.active1
        Case 0:
            If cs.autocenter Then 'stick auto-recenter (speed) ->
                cs.px1 = cs.px1 - Sqrt(Abs(sx1)) * sign(sx1) * 0.40 * fss
                cs.py1 = cs.py1 - Sqrt(Abs(sy1)) * sign(sy1) * 0.20 * fss			
            End If
        Case 1:
            mx1 = cs.mx1 - cs.mx0 'mouse1 movement
            my1 = cs.my1 - cs.my0
            cs.px1 = cs.px1 + mx1 * mscx
            cs.py1 = cs.py1 + my1 * mscy
            cs.mx0 = cs.mx1 'consume mouse1 movement.x
            cs.my0 = cs.my1 'consume mouse1 movement.y		
        Case Else
    End Select
	
	Select Case cs.active2
        Case 0:
            If cs.autocenter Then 'stick auto-recenter (speed) ->
                cs.px3 = cs.px3 - Sqrt(Abs(sx3)) * sign(sx3) * 0.40 * fss
                cs.py3 = cs.py3 - Sqrt(Abs(sy3)) * sign(sy3) * 0.20 * fss				
            End If
			sounds.setVolume(sounds.sndNoise1, 0.0)
			sounds.setVolume(sounds.sndNoise3, 0.0)
        Case 1:
            mx3 = cs.mx3 - cs.mx2 'mouse2 movement
            my3 = cs.my3 - cs.my2
           	cs.px3 = cs.px3 + mx3 * mscx
            cs.py3 = cs.py3 + my3 * mscy 
            cs.mx2 = cs.mx3 'consume mouse2 movement.x
            cs.my2 = cs.my3 'consume mouse2 movement.y
			cs.speedZ  = cs.speedZ - sy3 * 0.0008 * fss
			
			vol = unify(Abs(sy3) / 250) 	'250 ~ window.sizeY * 0.32
			If sy3 < 0 Then
				sounds.setVolume(sounds.sndNoise3, 0.0)
				sounds.setVolume(sounds.sndNoise1, vol)
			Else: sounds.setVolume(sounds.sndNoise1, 0.0)
				  sounds.setVolume(sounds.sndNoise3, vol)	
			End If
        Case Else
    End Select
	
	sounds.setVolume(sounds.sndNoise2, unify(Abs(cs.speedZ) * 0.04)) 
	sounds.setVolume(sounds.sndNoise4, unify(Abs(sx1) * 0.0016)) 
	sounds.setVolume(sounds.sndNoise5, unify(Abs(sy1) * 0.0025))
	
    input_cameraMove(fm, sx1, sy1)
    cs.speedZ = cs.speedZ * cs.frictZ 'decelerate camera
End Sub

Private Sub input_cameraMove(fm As xform3, dx As Float, dy As Float)
    
    Dim alt As Float
    Dim y, ay, ry, sy As Float
    Dim cs As control2 = input.control
    
    Dim fr1 As Float = 0.0
    Dim fr2 As Float = 0.0
    Dim fr3 As Float = 0.0
    
    alt = fm.ay(0)

    fr3 = fr3 - dx * 0.0004
    fr1 = fr1 + dy * 0.0004   
         
    'f0_rot! = f0_rot! * 0.998
    fr1 = fr1 * 0.97: fr3 = fr3 * 0.97

    'Compensate Matrix-"slipping" ->
    y = fm.ay(1): ay = Abs(y): sy = sign(y): ry = Sqrt(ay)
    'Up/Down Rotation
    fr1 = -(fr1 - ay * 0.0024)
    'Left/Right Rotation
    fr2 = -(y * 0.018)
    'Levelout Rotation
    'If ay < 0.40 Then fr3 = fr3 - ry * sy * 0.030

    fm.rotate2 (fr1, fr2, fr3)
    fm.moveZ (cs.speedZ)
End Sub

	
Private Sub sign(v As Float) As Float

	If v > 0 Then Return 1
	If v = 0 Then Return 0
	If v < 0 Then Return -1
End Sub

Private Sub unify(v As Float) As Float

	If v < 0.0 Then v = 0.0
	If v > 1.0 Then v = 1.0
	Return v
End Sub

'aka. clip, truncate, limit, cut, saturate
Private Sub clamp(v As Float, vmin As Float, vmax As Float) As Float 

	If v > vmax Then v = vmax
	If v < vmin Then v = vmin
	Return v
End Sub
