﻿Type=Class
Version=2.52
@EndOfDesignText@

Sub Class_Globals
	
	Private mm As mainCls
End Sub

Public Sub Initialize(mm0 As mainCls) As Boolean

	mm = mm0 
End Sub

Public Sub build_crate(m As mesh3, rx As Float, ry As Float, rz As Float)

    Dim ms As materialsCls = mm.materials
    Dim ma() As Int = Array As Int(ms.iWood1, ms.iCyan1, ms.iGreen1, ms.iLemon1, ms.iOrange1, ms.iViolet1, ms.iMagenta1)
    
    m.init(8, 12, 6)

    m.setLineMate(ma(0))
    m.setFaceMate(ma(0))

    m.setPoint(0, -rx,  ry, -rz): m.setPoint(4, -rx,  ry,  rz)
    m.setPoint(1,  rx,  ry, -rz): m.setPoint(5,  rx,  ry,  rz)
    m.setPoint(2, -rx, -ry, -rz): m.setPoint(6, -rx, -ry,  rz)
    m.setPoint(3,  rx, -ry, -rz): m.setPoint(7,  rx, -ry,  rz)
  
    m.setLine(0, 0, 1): m.setLine(4, 0, 2): m.setLine(8, 0, 4)
    m.setLine(1, 2, 3): m.setLine(5, 1, 3): m.setLine(9, 1, 5)
    m.setLine(2, 4, 5): m.setLine(6, 4, 6): m.setLine(10, 2, 6)
    m.setLine(3, 6, 7): m.setLine(7, 5, 7): m.setLine(11, 3, 7)

    m.setFaceMate(ma(1)): m.setFace4(0, 0, 1, 3, 2)
    m.setFaceMate(ma(2)): m.setFace4(3, 4, 0, 2, 6)
    m.setFaceMate(ma(3)): m.setFace4(1, 5, 4, 6, 7)
    m.setFaceMate(ma(4)): m.setFace4(4, 0, 4, 5, 1)
    m.setFaceMate(ma(5)): m.setFace4(2, 1, 5, 7, 3)
    m.setFaceMate(ma(6)): m.setFace4(5, 2, 3, 7, 6) 

    'm.setFace4(0, 0, 1, 3, 2): m.setFace4(3, 4, 0, 2, 6)
    'm.setFace4(1, 5, 4, 6, 7): m.setFace4(4, 0, 4, 5, 1)
    'm.setFace4(2, 1, 5, 7, 3): m.setFace4(5, 2, 3, 7, 6) 
End Sub

Public Sub build_sphere_1(m As mesh3, segments As Int, radius As Float)

    Dim c, f As Int
    Dim i, j As Int
    Dim n As Int = segments
    Dim a1, x1 As Double
    Dim a2, x2 As Double
    Dim ad As Double = cPI*2 / n
    Dim m1 As Int = mm.materials.iRubber1
    Dim up As point3: up.Initialize '= New point3()
    Dim eye As point3: eye.Initialize '= New point3()
	
    m.init(n*3, 0, n*3)

    a1 = 0: a2 = cPI/2
    i = 0
    For c = 1 To n
        x1 = Sin(a1) * radius: a1 = a1 - ad
        x2 = Sin(a2) * radius: a2 = a2 - ad
        m.setPoint(i, x1, x2, 0.0)
        m.setPoint(i+n, x1, 0.0, x2)
        m.setPoint(i+n+n, 0.0, x1, x2)
        i = i + 1
    Next

    i = 0: j = 1
    f = 0
    For c = 1 To n
        m.setFaceMate(m1)
        m.setFace2(f, i, j, eye): f = f + 1
        m.setFace2(f, i+n, j+n, eye): f = f + 1
        m.setFace2(f, i+n+n, j+n+n, eye): f = f + 1
        i = i + 1
        j = (j + 1) Mod n
    Next
End Sub

Private Sub Sign(v As Int) As Int

	If v > 0 Then Return 1
	If v = 0 Then Return 0
	If v < 0 Then Return -1
End Sub


Private Sub build_sphereCrossPoints(m As mesh3, p As Int, a1 As Int, a2 As Int, a3 As Int, _
                                    d1 As Double, d2 As Double, r0 As Double, r1 As Double, r2 As Double)
    Dim i As Int
    Dim c(8+1, 3+1) As Double

    Dim s1 As Double = Sign(a1): a1 = Abs(a1)
    Dim s2 As Double = Sign(a2): a2 = Abs(a2)
    Dim s3 As Double = Sign(a3): a3 = Abs(a3)
        
    c(0, a1) = 0.0: c(0, a2) = 0.0: c(0, a3) = r0

    c(1, a1) = -d1: c(1, a2) =  d1: c(1, a3) = r1
    c(2, a1) =  d1: c(2, a2) =  d1: c(2, a3) = r1
    c(3, a1) = -d1: c(3, a2) = -d1: c(3, a3) = r1
    c(4, a1) =  d1: c(4, a2) = -d1: c(4, a3) = r1

    c(5, a1) = 0.0: c(5, a2) =  d2: c(5, a3) = r2
    c(6, a1) =  d2: c(6, a2) = 0.0: c(6, a3) = r2
    c(7, a1) = -d2: c(7, a2) = 0.0: c(7, a3) = r2
    c(8, a1) = 0.0: c(8, a2) = -d2: c(8, a3) = r2
    
    For i = 0 To 8
        c(i, a1) = c(i, a1) * s1
        c(i, a2) = c(i, a2) * s2
        c(i, a3) = c(i, a3) * s3
        m.setPoint(p+i, c(i, 1), c(i, 2), c(i, 3))
    Next   
End Sub

Public Sub build_sphere_2(m As mesh3, radius As Float)

    Dim c, f As Int
    Dim p, i As Int
    Dim n As Int = 8+1
    Dim m1 As Int
    Dim ms As materialsCls = mm.materials
    Dim ma() As Int = Array As Int(ms.iCyan1, ms.iGreen1, ms.iLemon1, ms.iOrange1, ms.iViolet1, ms.iMagenta1)

    Dim r0 As Double = radius
    Dim d1 As Double = r0 * 0.14
    Dim d2 As Double = r0 * 0.36
    Dim r1 As Double = Sqrt(r0*r0 - d1*d1)
    Dim r2 As Double = Sqrt(r0*r0 - d2*d2)
    
    m.init(n*6, 0, 4*6)
    p = 0

    build_sphereCrossPoints (m, p, 1, 2, 3, d1, d2, -r0, -r1, -r2): p = p + n
    build_sphereCrossPoints (m, p, -1, 2, 3, d1, d2, r0, r1, r2): p = p + n 
    build_sphereCrossPoints (m, p, 3, 2, 1, d1, d2, r0, r1, r2): p = p + n
    build_sphereCrossPoints (m, p, -3, 2, 1, d1, d2, -r0, -r1, -r2): p = p + n 
    build_sphereCrossPoints (m, p, 1, 3, 2, d1, d2, r0, r1, r2): p = p + n
    build_sphereCrossPoints (m, p, -1, 3, 2, d1, d2, -r0, -r1, -r2): p = p + n 

    p = 0: i = 0
    f = 0
    For c = 0 To 5
        m1 = ma(i Mod 6): i = i + 1
        m.setFaceMate(m1)
        m.setFace4(f, p+0, p+1, p+5, p+2): f = f + 1
        m.setFace4(f, p+0, p+4, p+8, p+3): f = f + 1
        m1 = ma(i Mod 6): i = i + 1
        m.setFaceMate(m1)
        m.setFace4(f, p+0, p+2, p+6, p+4): f = f + 1
        m.setFace4(f, p+0, p+3, p+7, p+1): f = f + 1
        p = p + n
    Next
End Sub

Public Sub build_cask(m As mesh3, facets As Int, radius As Float, heigth As Float)

    Dim i, j As Int     
    Dim f, l As Int
    Dim c As Int
    Dim n As Int = facets
    Dim p1 As Int = facets*2 + 0
    Dim p2 As Int = facets*2 + 1
    Dim y1 As Double = 0.0 + heigth/2
    Dim y2 As Double = 0.0 - heigth/2
    Dim ax, px As Double
    Dim az, pz As Double
    Dim ad As Double = cPI*2 / n 
    Dim m1 As Int
    Dim m2 As Int
    Dim ms As materialsCls = mm.materials
    Dim ma() As Int = Array As Int(ms.iMetal1, ms.iCyan1, ms.iGreen1, ms.iLemon1, ms.iOrange1, ms.iOrange2,  ms.iMagenta1, ms.iViolet1)

    m.init(n*2+2, n*3, n*3)

    m.setLineMate(ma(0))         
    m.setFaceMate(ma(0)) 

    'setup points --->
    ax = 0: az = -cPI/2
    i = 0: j = n
    c = n
    Do While (c > 0)
        px = Sin(ax) * radius
        pz = Sin(az) * radius
        m.setPoint(i, px, y1, pz): i = i + 1: ax = ax + ad
        m.setPoint(j, px, y2, pz): j = j + 1: az = az + ad
        c = c - 1
    Loop
    m.setPoint(p1, 0, y1, 0)
    m.setPoint(p2, 0, y2, 0)
    
    'setup lines --->
    l = 0: i = 0: j = n
    For c = 1 To n  
        m.setLine(l, i, j): l = l + 1
        i = i + 1: j = j + 1
    Next
    l = 0: i = 0: j = 1
    For c = 1 To n  
        m.setLine(l, i, j): l = l + 1
        m.setLine(l, i+n, j+n): l = l + 1
        i = i + 1: j = (j + 1) Mod n
    Next

    'setup faces --->
    f = 0: i = 0: j = 1
    For c = 1 To n
        m1 = ma(1 + (i Mod 4))
        m.setFaceMate(m1)
        m.setFace4(f, i, j, j+n, i+n): f = f + 1
        i = i + 1: j = (j + 1) Mod n
    Next
    f = f: i = 0: j = 1
    For c = 1 To n
        m1 = ma(4 + (i Mod 4))
        m.setFaceMate(m1)
        m.setFace3(f, p1, j, i): f = f + 1
        m2 = ma(4 + (j Mod 4))
        m.setFaceMate(m2)
        m.setFace3(f, p2, i+n, j+n): f = f + 1
        i = i + 1: j = (j + 1) Mod n
    Next
End Sub

Public Sub build_checkers4(m As mesh3, squaresPerRow As Int, squareSize As Float)

    Dim i, x As Int
    Dim f, z As Int
    Dim n0 As Int = squaresPerRow
    Dim n1 As Int = squaresPerRow+1
    Dim m1 As Int
    Dim ms As materialsCls = mm.materials
    Dim ma() As Int = Array As Int(ms.iMagenta1, ms.iViolet1, ms.iOrange1, ms.iOrange2)
    Dim px, py, pz As Double
    Dim s4 As Float = squareSize * 0.25

    Dim p1 As Int = 0
    Dim p2 As Int = n0
    Dim p3 As Int = n1*n0
    Dim p4 As Int = n1*n0+n0
    Dim p5, p6, p7, p8 As Int 

    m.init(n1*n1+4, n0*n0*2, n0*n0+4)
    m.setLineMate(ma(0))         
    m.setFaceMate(ma(0)) 

    'setup points --->  
    i = 0: py = 0.0
    z = 0
    Do While (z < n1)
        x = 0
        Do While (x < n1)
            px = (x - n0/2) * squareSize
            pz = -(z - n0/2) * squareSize
            m.setPoint(i, px, py, pz): i = i + 1
            x = x + 1
        Loop: z = z + 1
    Loop

    m.setPoint(i, m.px(p1)-s4, -1.0, m.pz(p1)+s4): p5 = i: i = i + 1
    m.setPoint(i, m.px(p2)+s4, -1.0, m.pz(p2)+s4): p6 = i: i = i + 1
    m.setPoint(i, m.px(p3)-s4, -1.0, m.pz(p3)-s4): p7 = i: i = i + 1
    m.setPoint(i, m.px(p4)+s4, -1.0, m.pz(p4)-s4): p8 = i: i = i + 1

    'setup faces --->  
    f = 0: i = 0
    z = 0
    Do While (z < n0)
        x = 0
        Do While (x < n0)
            i = z*n1 + x
            m1 = ma((x + z) Mod 2)
            m.setFaceMate(m1)
            m.setFace4(f, i, i+1, i+n1+1, i+n1): f = f + 1
            x = x + 1
        Loop: z = z + 1
    Loop

    m.setFaceMate(ma(2))
    m.setFace4(f, p5, p6, p2, p1): f = f + 1
    m.setFace4(f, p1, p3, p7, p5): f = f + 1
    m.setFaceMate(ma(3))
    m.setFace4(f, p4, p2, p6, p8): f = f + 1
    m.setFace4(f, p3, p4, p8, p7): f = f + 1
End Sub

Public Sub build_checkers3(m As mesh3, squaresPerRow As Int, squareSize As Float)

    Dim i, x As Int
    Dim f, z As Int
    Dim n As Int = squaresPerRow
    Dim n1 As Int = squaresPerRow+1
    Dim m1 As Int
    Dim ms As materialsCls = mm.materials
    Dim ma() As Int = Array As Int(ms.iGray1, ms.iGray2)
    Dim px, py, pz As Double
    Dim s4 As Float = squareSize * 0.25

    m.init(n1*n1, n*n*2, n*n*2)

    'setup points --->  
    i = 0: py = 0.0
    z = 0
    Do While (z < n1)
        x = 0
        Do While (x < n1)
            px = (x - n/2) * squareSize
            pz = -(z - n/2) * squareSize
            m.setPoint(i, px, py, pz): i = i + 1
            x = x + 1
        Loop: z = z + 1
    Loop

    'setup faces --->  
    f = 0: i = 0
    z = 0
    Do While (z < n)
        x = 0
        Do While (x < n)
            i = z*n1 + x
            m1 = ma((x + z) Mod 2)
            m.setFaceMate(m1)
            m.setFace3(f, i, i+1, i+n1): f = f + 1
            m.setFace3(f, i+n1+1, i+n1, i+1): f = f + 1
            x = x + 1
        Loop: z = z + 1
    Loop
End Sub

