﻿Type=Class
Version=2.52
@EndOfDesignText@

Sub Class_Globals

	Public idx As Int
	Public active As Boolean
	Public stype As Int  'shape-type: body=1, ground=2, shadow=3(unused)
	Public show_radius As Boolean 'show shape hull-radius

	Public mesh As mesh3
	Public form As xform3  '3x4 matrix for transformation and translation
	Public gout As gout3   'geometry/graphics output, contains cam-transformed data: tform, points, clipstates
End Sub

Public Sub Initialize() As Boolean

    init
End Sub

Public Sub init()

    idx = -1
    active = False
    stype = 0
    mesh.Initialize '= New mesh3()
    form.Initialize '= New xform3()
    gout.Initialize '= New gout3()
End Sub

Public Sub reset(shapeID As Int)

    idx = shapeID
    active = True
End Sub

Public Sub mesh_load(m As mesh3) 'copy mesh from source to target

    Dim i As Int

    mesh.init (m.pnum, m.lnum, m.fnum)
    gout.init (m.pnum, m.fnum)

    mesh.pnum = m.pnum: gout.pnum = m.pnum
    mesh.lnum = m.lnum: gout.fnum = m.fnum
    mesh.fnum = m.fnum

    For i = 0 To m.fnum-1: mesh_copy_face (i, m, mesh): Next
    For i = 0 To m.lnum-1: mesh_copy_line (i, m, mesh): Next
    For i = 0 To m.pnum-1: mesh_copy_point (i, m, mesh): Next

    mesh.radiusInner = m.radiusInner
    mesh.radiusOuter = m.radiusOuter
    gout.hrad_inner = m.radiusInner
    gout.hrad_outer = m.radiusOuter
End Sub

Private Sub mesh_copy_face(i As Int, m1 As mesh3, m2 As mesh3)

    'm2.fnum = m1.fnum
    m2.fp1(i) = m1.fp1(i)
    m2.fp2(i) = m1.fp2(i)
    m2.fp3(i) = m1.fp3(i)
    m2.fp4(i) = m1.fp4(i)
    m2.fcx(i) = m1.fcx(i): m2.fcy(i) = m1.fcy(i): m2.fcz(i) = m1.fcz(i)
    m2.fnx(i) = m1.fnx(i): m2.fny(i) = m1.fny(i): m2.fnz(i) = m1.fnz(i)
    m2.fmate(i) = m1.fmate(i)
    m2.ftype(i) = m1.ftype(i)
End Sub

Private Sub mesh_copy_line(i As Int, m1 As mesh3, m2 As mesh3)

    'm2.lnum = m1.lnum
    m2.lp1(i) = m1.lp1(i)
    m2.lp2(i) = m1.lp2(i)
    m2.lmate(i) = m1.lmate(i)
End Sub

Private Sub mesh_copy_point(i As Int, m1 As mesh3, m2 As mesh3)

    'm2.pnum = m1.pnum
    m2.px(i) = m1.px(i): m2.py(i) = m1.py(i): m2.pz(i) = m1.pz(i)
End Sub
