﻿Type=Class
Version=2.52
@EndOfDesignText@

Sub Class_Globals

	Private smode As Int = 1

	'sound list (apply changes here, remember to update sndCount)
	Public sndNoise1 As Int = 0, fileNoise1 As String = "noise112.ogg"
	Public sndNoise2 As Int	= 1, fileNoise2 As String = "noise42.ogg"
	Public sndNoise3 As Int	= 2, fileNoise3 As String = "noise32.ogg"
	Public sndNoise4 As Int	= 3, fileNoise4 As String = "noise41.ogg"
	Public sndNoise5 As Int	= 4, fileNoise5 As String = "noise45.ogg"
	Public sndCount  As Int = 5

	Type soundCls (sp As SoundPool, spi As Int, loadID As Int, playID As Int, fname As String) 'this sp is used for smode 1

	Private sp As SoundPool  'this sp is used for smode 2
	
	Private sound() As soundCls
	Private sndDir As String

	Public loadOk As Boolean 	'callee can use this for error-handling
	Public startOk As Boolean 	'callee can use this for error-handling
	
	Private startTm As Timer
	Private startTmOk As Boolean
End Sub

Public Sub Initialize(mode As Int)
	
	If mode = 1 Then smode = 1
	If mode = 2 Then smode = 2
	
	sndDir = File.DirAssets: Log ("soundDir: " & sndDir)
	Dim sound(sndCount) As soundCls
	
	startTm.Initialize("startTm", 1000) 'give each sound one second max. to be loaded (change by own consideration)
	startTm.Enabled = False

	If smode = 2 Then sp.Initialize(sndCount) 'in smode 2, all streams are put into one pool
End Sub

Public Sub load_sounds(logs As Boolean)
	
	Dim s As String = "Load Sounds.. "
	If logs Then Log(s)
    
	loadOk = True
	load_sound(sndNoise1, fileNoise1)
	load_sound(sndNoise2, fileNoise2)
	load_sound(sndNoise3, fileNoise3)
	load_sound(sndNoise4, fileNoise4)
	load_sound(sndNoise5, fileNoise5)
	
	If logs Then log_result(s, loadOk)	
End Sub

Public Sub start_sounds(logs As Boolean)

	Dim s As String = "Start Sounds.. "
	If logs Then Log(s)

	startOk = True
	start_sound(sndNoise1)
	start_sound(sndNoise2)
	start_sound(sndNoise3)
	start_sound(sndNoise4)
	start_sound(sndNoise5)
	
	If logs Then log_result(s, startOk)
End Sub

Public Sub setVolume(si As Int, vol As Float)

	If si >= 0 AND si < sndCount Then

		If vol < 0.0 Then vol = 0.0
		If vol > 1.0 Then vol = 1.0
	
		If smode = 1 Then sound(si).sp.setVolume(sound(si).playID, vol, vol)
		If smode = 2 Then sp.setVolume(sound(si).playID, vol, vol)
		'Log ("setVolume() s" & si & " vol:" & vol)
	End If		
End Sub

Private Sub load_sound(si As Int, sname As String)

	Dim loadID As Int

	sound(si).Initialize
	If smode = 1 Then sound(si).sp.Initialize(1) 'in smode 1, each stream gets it's own pool
	If smode = 1 Then loadID = sound(si).sp.Load(sndDir, sname)
	If smode = 2 Then loadID = sp.Load(sndDir, sname)
	
	sound(si).loadID = loadID
	sound(si).fname = sname
	
	If loadID = 0 Then loadOk = False
	'Log ("load_sound() s" & si & " fname:" & sname & " loadID:" & loadID)
End Sub

Private Sub start_sound(si As Int)

	Dim playID As Int = 0
	
	startTmOk = True
	startTm.Enabled = True
	
	Do While startTmOk
		
		If smode = 1 Then playID = sound(si).sp.play(sound(si).loadID, 0.0, 0.0, 0, -1, 1.0)
		If smode = 2 Then playID = sp.play(sound(si).loadID, 0.0, 0.0, 0, -1, 1.0)
		
		If playID > 0 Then Exit
	Loop
	startTm.Enabled = False
	sound(si).playID = playID
	
	If playID = 0 Then startOk = False
	'Log ("start_sound() s" & si & " playID:" & playID)
End Sub


Private Sub startTm_Tick

	startTmOk = False
End Sub

Private Sub log_result(s As String, ok As Boolean)

	If ok Then 
	 	 Log (s & "ok")
	Else: Log (s & "FAIL!")
	End If
End Sub


'Public Sub setVolume_OLD(si As Int, vol As Float)
'
'	If si >= 0 AND si < sndMax Then
'
'		If vol < 0.0 Then vol = 0.0
'		If vol > 1.0 Then vol = 1.0
'	
'		sound(si).sp.setVolume(sound(si).playID, vol, vol)
'		'Log ("setVolume() s" & si & " vol:" & vol)
'	End If		
'End Sub
'
'Private Sub load_sound_OLD(si As Int, sname As String)
'
'	Dim loadID As Int
'
'	sound(si).Initialize
'	sound(si).sp.Initialize(1)
'	
'	loadID = sound(si).sp.Load(sndDir, sname)
'	sound(si).loadID = loadID
'	sound(si).fname = sname
'	
'	If loadID = 0 Then loadOk = False
'	'Log ("load_sound() s" & si & " fname:" & sname & " loadID:" & loadID)
'End Sub
'
'Private Sub start_sound_OLD(si As Int)
'
'	Dim playID As Int = 0
'	
'	startTmOk = True
'	startTm.Enabled = True
'	
'	Do While startTmOk
'		playID = sound(si).sp.play(sound(si).loadID, 0.0, 0.0, 0, -1, 1.0)
'		If playID > 0 Then Exit
'	Loop
'	startTm.Enabled = False
'	sound(si).playID = playID
'	
'	If playID = 0 Then startOk = False
'	'Log ("start_sound() s" & si & " playID:" & playID)
'End Sub


